<template>
  <div :class="classes">
    <button
      type="button"
      class="main"
      :aria-pressed="ariaPressed"
      :aria-disabled="ariaDisabled"
      :disabled="disabled"
      @click="triggerToggle()"
    >
      <sa-icon
        v-if="loading"
        icon="loader"
        :size="size === 'large' ? '3' : '1'"
        spin
      />
      <sa-avatar
        v-else-if="avatar"
        :full-name="avatar"
        :size="size === 'large' ? 'regular' : 'small'"
      />
      <sa-icon
        v-else-if="icon"
        :icon="icon"
        :size="size === 'large' ? '3' : '1'"
      />
      <div class="text">{{ text }}</div>
    </button>
    <button
      v-if="canDelete"
      type="button"
      class="delete"
      :disabled="disabled"
      @click="triggerDelete"
    >
      <span class="sr-only">Delete {{ text }}</span>
      <sa-icon icon="x" :size="size === 'large' ? '1' : '0'" />
    </button>
  </div>
</template>

<script>
export default {
  name: 'SaChip',
  props: {
    /** @values primary, success, error */
    type: {
      type: String,
      default: 'primary'
    },
    /** @values small, regular, large */
    size: {
      type: String,
      default: 'regular'
    },
    /** Chip label */
    text: {
      type: String,
      required: true
    },
    /** Name of icon to display in the chip. See the Icons page for available icon names. */
    icon: {
      type: String,
      default: ''
    },
    /** Name of user to show an `avatar` for. */
    avatar: {
      type: String,
      default: ''
    },
    /** Show a loading spinner in the chip. */
    loading: {
      type: Boolean,
      default: false
    },
    /** Show a delete button in the chip. */
    canDelete: {
      type: Boolean,
      default: false
    },
    /** Allow the chip state to be toggled on/off. */
    canToggle: {
      type: Boolean,
      default: false
    },
    /** Show chip in 'selected' state. */
    selected: {
      type: Boolean,
      default: false
    },
    /** Show chip in disabled state and disable all user interaction. */
    disabled: {
      type: Boolean,
      default: false
    }
  },
  data() {
    return {
      toggleSelected: false
    }
  },
  computed: {
    classes() {
      return [
        'chip',
        this.type,
        this.size,
        { loading: this.loading },
        { selected: this.toggleSelected && !this.disabled && !this.loading },
        { toggle: this.canToggle && !this.disabled && !this.loading },
        { disabled: this.disabled }
      ]
    },
    ariaPressed() {
      // if disabled or loading do not add aria-pressed attribute
      if (this.disabled || this.loading) {
        return false
        // else show aria-pressed as 'true' or 'false' based on toggleSelected
      } else {
        return this.toggleSelected ? 'true' : 'false'
      }
    },
    ariaDisabled() {
      // if disabled do not add aria-disabled attribute
      if (this.disabled) {
        return false
        // else show aria-disabled based on canToggle or loading
      } else {
        return !this.canToggle || this.loading
      }
    }
  },
  created() {
    this.toggleSelected = !!this.selected
  },
  methods: {
    triggerToggle() {
      if (this.canToggle && !this.loading) {
        this.toggleSelected = !this.toggleSelected
        /** Emitted when chip is toggled on or off */
        this.$emit('toggle')
      }
    },
    triggerDelete() {
      /** Emitted when chip delete button is pressed */
      this.$emit('delete')
    }
  }
}
</script>

<style lang="scss" scoped>
.chip {
  display: inline-flex;
  border-radius: 2rem;
  overflow: hidden;
  transition: $transition;
  .main,
  .delete {
    &:hover,
    &:focus {
      outline: 0;
    }
  }
  .main {
    display: flex;
    align-items: center;
    text-align: left;
    &[aria-disabled='true'] {
      cursor: default;
    }
    &[disabled] {
      color: color(grey);
      cursor: not-allowed;
    }
    .avatar,
    .icon {
      position: absolute;
    }
  }
  .delete {
    transition: $transition;
  }
  &.small {
    .text,
    .delete {
      padding: spacing(0) spacing(1);
    }
    .main {
      * + * {
        margin-left: font-size(2);
      }
      .icon {
        margin-left: spacing(0);
      }
    }
  }
  &.regular {
    .text,
    .delete {
      padding: spacing(1);
    }
    .main {
      * + * {
        margin-left: font-size(3);
      }
      .avatar {
        margin-left: spacing(0);
      }
      .icon {
        margin-left: spacing(1);
      }
    }
  }
  &.large {
    .text,
    .delete {
      padding: spacing(2);
    }
    .main {
      * + * {
        margin-left: font-size(4);
      }
      .avatar {
        margin-left: spacing(0);
      }
      .icon {
        margin-left: spacing(2);
      }
    }
  }
}

$types: 'primary', 'success', 'danger';
@each $type in $types {
  .#{$type} {
    border: border(#{$type}-light);
    &:focus,
    &:focus-within,
    &.toggle:hover {
      border: border(#{$type}-dark);
      box-shadow: inset 0px 0px 0px 1px color(#{$type}-dark), $box-shadow;
    }
    &.selected {
      border: border(#{$type}-dark);
      background: color(#{$type}-tint);
    }
    .main .icon {
      color: color(#{$type}-dark);
    }
    .delete {
      border-left: border(#{$type}-light);
      &:hover,
      &:focus {
        border-left: border(#{$type}-dark);
        color: color(white);
        background: color(#{$type}-dark);
      }
    }
  }
}
.loading {
  border: border(primary);
  background: color(primary-tint);
  .main .icon {
    color: color(primary);
  }
  .delete {
    border-left: border(primary-light);
    &:hover,
    &:focus {
      border-left: border(primary);
      color: color(white);
      background: color(primary);
    }
  }
}
.disabled {
  border: border(grey-light);
  color: color(grey);
  background: color(grey-tint);
  &:focus-within {
    border: border(grey);
    box-shadow: inset 0px 0px 0px 1px color(grey), $box-shadow;
  }
  .main .icon {
    color: color(grey);
  }
  .delete {
    cursor: not-allowed;
    border-left: border(grey-light);
    &:hover,
    &:focus {
      border-color: color(grey-light);
      color: color(grey);
      background: color(grey-tint);
    }
  }
}
</style>
